#!/usr/bin/perl

=head1 NAME

updatemarc_subjects.pl

=head1 AUTHOR

Waylon Robertson genji18@yahoo.co.nz

=head1 DESCRIPTION

This script is useful only for libraries with MARC=OFF (MARC=0)
It rebuild the subjects in the MARC table from the non MARC tables.

It is almost the same as koha2marc.pl, except it deals only biblios with a subject, being faster than koha2marc.pl

=cut

BEGIN{
my $path = "C:/usr/koha200pre2/modules";
push(@INC,$path);
}
use strict;
use C4::Context;
use C4::Database;
use MARC::Record;
use C4::Biblio;

print("Syncing MARCbiblio with old-db data, including subjects.");
      if (C4::Context->preference("MARC") eq '0'){
          my $dbh = C4::Context->dbh;
          my $query="select * from bibliosubject";
          my $sth=$dbh->prepare($query);
          $sth->execute();
          my $i;
          while (my $data=$sth->fetchrow_hashref){
              $i++;
              my $bibnum=$data->{'biblionumber'};
              my $MARCRecord = &MARCkoha2marcBiblio($dbh,$bibnum);
              my $bibid = &MARCfind_MARCbibid_from_oldbiblionumber($dbh,$bibnum);
              &MARCmodbiblio($dbh,$bibid, $MARCRecord);
              if($i eq '50'){
                  $i=0;
                  print("$bibnum\n");
              }
          }
      } else {
      print ("Syncing not necessary in MARC=ON enviroment.");
      };


